########################################################
### R script to perform GSEA on somatic mutations    ###
### (Sup Data 5) and data from Peifer et al., 2012   ###
########################################################

## load libraries
library(readxl)

## loading data
project_path <- "C:/Users/33659/Desktop/Fisher Hallmarks"
Supplementary=data.frame(read_excel(paste0("Y:/LungNENomics/Submissions/SubmissionNatCommun","/SupplementaryTables.xlsx"),sheet = 2))
head(Supplementary)
colnames(Supplementary)<-as.character(Supplementary[3,])
Supplementary <- Supplementary[-(1:3),]
head(Supplementary)
Supplementary <- Supplementary[which(!Supplementary$Sample_ID == "S00716_A"),] #remove the technical replicate
Supplementary[Supplementary == "NA"] <- NA
Supplementary[which(!is.na(as.numeric(Supplementary$`Gene Symbol`))),"Gene Symbol"]
Supplementary[which(Supplementary$`Gene Symbol` == "37500"),"Gene Symbol"] <- "SEPT2"
dim(Supplementary)

# load data from Peifer et al., 2012
Supplementary_table_G=data.frame(read_excel(paste0("Y:/LungNENomics/data/Mutation","/NIHMS793416-supplement-Supplemental_Tables.xlsx"),sheet = 9)) 
head(Supplementary_table_G)
colnames(Supplementary_table_G)<-as.character(Supplementary_table_G[4,])
Supplementary_table_G <- Supplementary_table_G[-(1:4),]
head(Supplementary_table_G)
Supplementary_table_G[Supplementary_table_G == "NA"] <- NA
Supplementary_table_G[which(!is.na(as.numeric(Supplementary_table_G$`Gene.Symbol`))),"Gene.Symbol"]
Supplementary_table_G[which(Supplementary_table_G$Gene.Symbol == "37499"),"Gene.Symbol"] <- "SEPT6"
Supplementary_table_G[which(Supplementary_table_G$Gene.Symbol == "37315"),"Gene.Symbol"] <- "MARCH6"
list_SCLC <- as.character(unique(Supplementary_table_G[which(Supplementary_table_G[,19] == "yes" | Supplementary_table_G[,14] == "validated"),"Sample"]))
list_SCLC <- list_SCLC[which(!list_SCLC %in% c("H1672","H2171"))]
"S02322" %in% list_SCLC
length(list_SCLC) == 27
Supplementary_table_G <-Supplementary_table_G[which(Supplementary_table_G[,1] %in% list_SCLC & (Supplementary_table_G[,19] == "yes" | Supplementary_table_G[,14] == "validated") & !Supplementary_table_G[10] == "silent" & !Supplementary_table_G[10] == "intron_exon"),]
colnames(Supplementary_table_G)[2] <- "Gene Symbol"
dim(Supplementary_table_G) == "1562"

Hallmarks_of_Cancer_TGen <- read.delim(paste0("Y:/Users/mangiantel/PCA/NL-mutations/DATA","/Hallmarks_of_Cancer_TGen.txt"))
head(Hallmarks_of_Cancer_TGen)
Hallmarks_of_Cancer_TGen[which(!is.na(as.numeric(Hallmarks_of_Cancer_TGen[,2]))),2]
dim(Hallmarks_of_Cancer_TGen)

#Process Figure 5C 

SCa <- unique(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"])
SCa

Supplementary$Validation_Method
A1_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),9]
A1_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'& !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),"Sample_ID"]
A1_su<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),]

A1_all_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) ),9]
A1_all_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'& !is.na(Supplementary$Validation_Method) ),"Sample_ID"]
A1_all_su<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) ),]

A2_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),9]
A2_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
A2_su<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),]

B_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),9]
B_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
B_su<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),]

LCNEC_mu<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),9]
LCNEC_id<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
LCNEC_su<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),]

SCLC_mu<-Supplementary_table_G[,"Gene Symbol"]
SCLC_id<-Supplementary_table_G[,"Sample"]
SCLC_su<-Supplementary_table_G

group <- c("A1","A1_all","A2","B","LCNEC","SCLC")
group_mu <- list(A1_mu,A1_all_mu,A2_mu,B_mu,LCNEC_mu,SCLC_mu, names = c("A1_mu","A1_all_mu","A2_mu","B_mu","LCNEC_mu","SCLC_mu"))
group_id <- list(A1_id,A1_all_id,A2_id,B_id,LCNEC_id,SCLC_id, names = c("A1_id","A1_all_id","A2_id","B_id","LCNEC_id","SCLC_id"))
group_su <- list(A1_su,A1_all_su,A2_su,B_su,LCNEC_su,SCLC_su, names = c("A1_su","A1_all_su","A2_su","B_su","LCNEC_su","SCLC_su"))

for(m in 1:length(group)){
  a<-as.character(group_mu[[m]])
  q<-as.character(group_id[[m]])
  s<-as.data.frame(cbind(q,a))
  Supplementary_table <- group_su[[m]]
  tab3<-as.data.frame(table(q))
  new<-data.frame()
  for(i in 1:nrow(tab3)){ #remove the duplicated mutated genes in a given sample 
    si<-s[which(s$q == tab3$q[i]),"a"]
    for(j in 1:length(si)){
      if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
        new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
      }
    }
  }
  a<-new$a
  q<-new$q #new
  l<-length(a)
  p2<-list()
  f2 <- data.frame()
  tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
  for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
    b<-Hallmarks_of_Cancer_TGen[,k]
    inter<-intersect(a,b)
    f2[k,1] <- colnames(Hallmarks_of_Cancer_TGen)[k]
    f2[k,2] <- paste(inter, collapse = ",")
    list.mu<-as.character(a)[which(as.character(a) %in% inter)]
    x<-length(list.mu)
    counts = (matrix(data = c(x, l-x, (as.numeric(tot[k])*(as.numeric(length(q)-sum(duplicated(q)))))-x, ((20345-as.numeric(tot[k]))*(as.numeric(length(q)-sum(duplicated(q)))))-l+x), nrow = 2))
    p2[k]<-(fisher.test(counts)$p.value)
    f2[k,3] <- p2[k]
    f2[k,4] <- fisher.test(counts)$conf.int[1]
    f2[k,5] <- fisher.test(counts)$conf.int[2]
    f2[k,6] <- fisher.test(counts)$estimate
    f2[k,7] <- fisher.test(counts)$null.value
  }
  f2[,8] <- p.adjust(p2,  method = "fdr")
  colnames(f2)[1] <- "Hallmarks of cancer"
  colnames(f2)[2] <- "Mutated genes"
  colnames(f2)[3] <- "p.value"
  colnames(f2)[4] <- "conf.int1"
  colnames(f2)[5] <- "conf.int2"
  colnames(f2)[6] <- "estimate"
  colnames(f2)[7] <- "null.value"
  colnames(f2)[8] <- "p.adjust"
  print(f2[,c(1,8)])
  write.table(f2,paste0("Y:/Users/mangiantel/PCA/NL-mutations/Results/", group[m] ,"_Hallmarks_3.txt"),row.names = F,col.names = T,quote = F, sep="\t")
}

#Process Figure 2B 
SCa_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),9]
SCa_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"]
SCa_su<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),]

a<-as.character(SCa_mu)
q<-as.character(SCa_id)
s<-as.data.frame(cbind(q,a))
Supplementary_table <- SCa_su
tab3<-as.data.frame(table(q))
new<-data.frame()
for(i in 1:nrow(tab3)){ #remove the duplicated mutated genes in a given sample 
  si<-s[which(s$q == tab3$q[i]),"a"]
  for(j in 1:length(si)){
    if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
      new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
    }
  }
}
a<-new$a
q<-new$q #new
l<-length(a)
p2<-list()
f2 <- data.frame()
tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
  b<-Hallmarks_of_Cancer_TGen[,k]
  inter<-intersect(a,b)
  f2[k,1] <- colnames(Hallmarks_of_Cancer_TGen)[k]
  f2[k,2] <- paste(inter, collapse = ",")
  list.mu<-as.character(a)[which(as.character(a) %in% inter)]
  x<-length(list.mu)
  counts = (matrix(data = c(x, l-x, (as.numeric(tot[k])*(as.numeric(length(q)-sum(duplicated(q)))))-x, ((20345-as.numeric(tot[k]))*(as.numeric(length(q)-sum(duplicated(q)))))-l+x), nrow = 2))
  p2[k]<-(fisher.test(counts)$p.value)
  f2[k,3] <- p2[k]
  f2[k,4] <- fisher.test(counts)$conf.int[1]
  f2[k,5] <- fisher.test(counts)$conf.int[2]
  f2[k,6] <- fisher.test(counts)$estimate
  f2[k,7] <- fisher.test(counts)$null.value
}
f2[,8] <- p.adjust(p2,  method = "fdr")
colnames(f2)[1] <- "Hallmarks of cancer"
colnames(f2)[2] <- "Mutated genes"
colnames(f2)[3] <- "p.value"
colnames(f2)[4] <- "conf.int1"
colnames(f2)[5] <- "conf.int2"
colnames(f2)[6] <- "estimate"
colnames(f2)[7] <- "null.value"
colnames(f2)[8] <- "p.adjust"
f2[,c(1,8)]
write.table(f2,"C:/Users/33659/Desktop/Fisher Hallmarks/SCa_Hallmarks_2.txt",row.names = F,col.names = T,quote = F, sep="\t")

#Supplementary Data 5 - Test per Supra Ca samples
Supplementary_table <- SCa_su

final<-data.frame()
for(u in 1:length(unique(SCa_id))){
  a<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC" & Supplementary$Sample_ID==unique(SCa_id)[u]),9]
  q<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"& Supplementary$Sample_ID==unique(SCa_id)[u]),"Sample_ID"]
  a<-as.character(a)
  q<-as.character(q)
  s<-as.data.frame(cbind(q,a))
  tab3<-as.data.frame(table(q))
  new<-data.frame()
  for(i in 1:nrow(tab3)){
    si<-s[which(s$q == tab3$q[i]),"a"]
    for(j in 1:length(si)){
      if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
        new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
      }
    }
  }
  a<-new$a
  q<-new$q #new
  l<-length(a)
  p1<-list()
  p3<-data.frame()
  tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
  for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
    b<-Hallmarks_of_Cancer_TGen[,k]
    inter<-intersect(a,b)
    list.mu<-as.character(a)[which(as.character(a) %in% inter)]
    x<-length(list.mu)
    counts = (matrix(data = c(x, l-x, (as.numeric(tot[k])*(as.numeric(length(q)-sum(duplicated(q)))))-x, ((20345-as.numeric(tot[k]))*(as.numeric(length(q)-sum(duplicated(q)))))-l+x), nrow = 2))
    p3[k,1]<-(fisher.test(counts)$conf.int[1])
    p3[k,2]<-(fisher.test(counts)$conf.int[2])
    p1[k]<-(fisher.test(counts)$p.value)
  }
  final[(1:10),u] <- p.adjust(p1,  method = "fdr")
  colnames(final)[u] <- as.character(unique(q))
}
rownames(final)[(1:10)] <- colnames(Hallmarks_of_Cancer_TGen)[(1:10)]
final
write.table(final,"C:/Users/33659/Desktop/Fisher Hallmarks/SCa_Hallmarks_per_samples_2.txt",row.names = T,col.names = T,quote = F, sep="\t")

#Supplementary Data 5 - Jacknife analyses for samples
A1_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'& !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),"Sample_ID"]
A2_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
B_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
LCNEC_id<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
SCLC_id<-Supplementary_table_G[,"Sample"]

SCa <- unique(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"])

A1_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),9])
names(A1_mu) <- A1_id

A2_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),9])
names(A2_mu) <- A2_id

B_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),9])
names(B_mu) <- B_id

LCNEC_mu<-as.list(Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),9])
names(LCNEC_mu) <- LCNEC_id

SCLC_mu<-as.list(as.character(Supplementary_table_G[,"Gene Symbol"]))
names(SCLC_mu) <- SCLC_id

group <- c("A1","A2","B","LCNEC","SCLC")
group_mu <- list(A1_mu,A2_mu,B_mu,LCNEC_mu,SCLC_mu, names = c("A1_mu","A2_mu","B_mu","LCNEC_mu","SCLC_mu"))
group_id <- list(A1_id,A2_id,B_id,LCNEC_id,SCLC_id, names = c("A1_id","A2_id","B_id","LCNEC_id","SCLC_id"))
group_su <- list(A1_su,A2_su,B_su,LCNEC_su,SCLC_su, names = c("A1_su","A2_su","B_su","LCNEC_su","SCLC_su"))

for(m in 1:length(group)){
  check_list <- as.character(unique(group_id[[m]]))
  final2<-data.frame()
  a<-group_mu[[m]]
  q<-group_id[[m]]
  Supplementary_table <- group_su[[m]]
  a<-as.character(a)
  q<-as.character(q)
  s<-as.data.frame(cbind(q,a))
  tab3<-as.data.frame(table(q))
  new<-data.frame()
  for(i in 1:nrow(tab3)){
    si<-s[which(s$q == tab3$q[i]),"a"]
    for(j in 1:length(si)){
      if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
        new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
      }
    }
  }
  for(u in (1:length(check_list))){
    a<-new[which(!new$q == check_list[u]),"a"]
    q<-new[which(!new$q == check_list[u]),"q"]
    l<-length(a)
    p1<-list()
    p3<-data.frame()
    tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
    for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
      b<-Hallmarks_of_Cancer_TGen[,k]
      inter<-intersect(a,b)
      list.mu<-as.character(a)[which(as.character(a) %in% inter)]
      x<-length(list.mu)
      counts = (matrix(data = c(x, l-x, (as.numeric(tot[k])*(as.numeric(length(q)-sum(duplicated(q)))))-x, ((20345-as.numeric(tot[k]))*(as.numeric(length(q)-sum(duplicated(q)))))-l+x), nrow = 2))
      p3[k,1]<-(fisher.test(counts)$conf.int[1])
      p3[k,2]<-(fisher.test(counts)$conf.int[2])
      p1[k]<-(fisher.test(counts)$p.value)
    }
    final2[(1:10),u] <- p.adjust(p1,  method = "fdr")
    colnames(final2)[u] <- check_list[u]
  }
  rownames(final2)[(1:10)] <- colnames(Hallmarks_of_Cancer_TGen)[(1:10)]
  print(final2)
  write.table(final2,paste0("Y:/Users/mangiantel/PCA/NL-mutations/Results/", group[m] ,"_SampleRemoved_Hallmarks_2.txt"),row.names = T,col.names = T,quote = F, sep="\t")
}

#Supplementary Data 5 - Mutated genes in each samples per hallmark
A1_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'& !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),"Sample_ID"]
A2_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
B_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
LCNEC_id<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),"Sample_ID"]
SCLC_id<-Supplementary_table_G[,"Sample"]
SCa_id<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"]

SCa_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1'  & Supplementary$Cluster_LNEN == "LCNEC"),9])
names(SCa_mu) <- SCa_id

SCa <- unique(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"])
A1_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),9])
names(A1_mu) <- A1_id

A2_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),9])
names(A2_mu) <- A2_id

B_mu<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),9])
names(B_mu) <- B_id

LCNEC_mu<-as.list(Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),9])
names(LCNEC_mu) <- LCNEC_id

SCLC_mu<-as.list(Supplementary_table_G[,"Gene Symbol"])
names(SCLC_mu) <- SCLC_id

group <- c("A1","A2","B","LCNEC","SCLC","SCa")
group_mu <- list(A1_mu,A2_mu,B_mu,LCNEC_mu,SCLC_mu,SCa_mu, names = c("A1_mu","A2_mu","B_mu","LCNEC_mu","SCLC_mu","SCa_mu"))
group_id <- list(A1_id,A2_id,B_id,LCNEC_id,SCLC_id,SCa_id, names = c("A1_id","A2_id","B_id","LCNEC_id","SCLC_id","SCa_id"))
group_su <- list(A1_su,A2_su,B_su,LCNEC_su,SCLC_su,SCa_su, names = c("A1_su","A2_su","B_su","LCNEC_su","SCLC_su","SCa_su"))

for(m in 1:length(group)){
  check_list <- unique(group_id[[m]])
  final3<-data.frame()
  for(u in (1:length(check_list))){
    a<-group_mu[[m]][which(names(group_mu[[m]])==check_list[u])]
    q<-group_id[[m]][which(group_id[[m]]==check_list[u])] 
    Supplementary_table <- group_su[[m]]
    a<-as.character(a)
    q<-as.character(q)
    s<-as.data.frame(cbind(q,a))
    tab3<-as.data.frame(table(q))
    new<-data.frame()
    for(i in 1:nrow(tab3)){
      si<-s[which(s$q == tab3$q[i]),"a"]
      for(j in 1:length(si)){
        if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
          new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
        }
      }
    }
    a<-new$a
    q<-new$q #new
    l<-length(a)
    tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
    for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
      b<-Hallmarks_of_Cancer_TGen[,k]
      inter<-intersect(a,b)
      list.mu<-as.character(a)[which(as.character(a) %in% inter)]
      if(!length(list.mu)==0){
        final3[k,u] <- paste(list.mu, collapse = ",")
      }
      else{
        final3[k,u] <- "NA"
      }
    }
    colnames(final3)[u] <- check_list[u]
  }
  rownames(final3)[(1:10)] <- colnames(Hallmarks_of_Cancer_TGen)[(1:10)]
  print(final3)
  write.table(final3,paste0("Y:/Users/mangiantel/PCA/NL-mutations/Results/", group[m] ,"_MutatedGenes_Hallmarks_2.txt"),row.names = T,col.names = T,quote = F, sep="\t")
}

#Supplementary Data 5 - Jacknife analyses for mutated genes
A1_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),9]
A2_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),9]
B_mu<-Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),9]
LCNEC_mu<-Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),9]
SCLC_mu<-Supplementary_table_G[,"Gene Symbol"]

SCa <- unique(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & Supplementary$Cluster_LNEN == "LCNEC"),"Sample_ID"])

A1_id<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A1' & !is.na(Supplementary$Validation_Method) & !Supplementary$Sample_ID %in% SCa),"Sample_ID"])
names(A1_id) <- A1_mu

A2_id<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca A2' & !is.na(Supplementary$Validation_Method)),"Sample_ID"])
names(A2_id) <- A2_mu

B_id<-as.list(Supplementary[which(Supplementary$Cluster_LNET=='Ca B' & !is.na(Supplementary$Validation_Method)),"Sample_ID"])
names(B_id) <- B_mu

LCNEC_id<-as.list(Supplementary[which(Supplementary$Histopathology %in% c('LCNEC', "LCNEC combined SqCC", "LCNEC combined SCLC") & !is.na(Supplementary$Validation_Method)),"Sample_ID"])
names(LCNEC_id) <- LCNEC_mu

SCLC_id<-as.list(Supplementary_table_G[,"Sample"])
names(SCLC_id) <- SCLC_mu

group <- c("A1","A2","B","LCNEC","SCLC")
group_mu <- list(A1_mu,A2_mu,B_mu,LCNEC_mu,SCLC_mu, names = c("A1_mu","A2_mu","B_mu","LCNEC_mu","SCLC_mu"))
group_id <- list(A1_id,A2_id,B_id,LCNEC_id,SCLC_id, names = c("A1_id","A2_id","B_id","LCNEC_id","SCLC_id"))
group_su <- list(A1_su,A2_su,B_su,LCNEC_su,SCLC_su, names = c("A1_su","A2_su","B_su","LCNEC_su","SCLC_su"))

for(m in 1:length(group)){ 
  check_list <- unique(group_mu[[m]])
  final2<-data.frame()
  a<-group_mu[[m]]
  q<-group_id[[m]]
  Supplementary_table <- group_su[[m]]
  a<-as.character(a)
  q<-as.character(q)
  s<-as.data.frame(cbind(q,a))
  tab3<-as.data.frame(table(q))
  new<-data.frame()
  for(i in 1:nrow(tab3)){
    si<-s[which(s$q == tab3$q[i]),"a"]
    for(j in 1:length(si)){
      if(duplicated(si)[j] == FALSE & !is.na(duplicated(si)[j])){
        new<-rbind(new,s[which(s$a == si[j] & s$q == tab3$q[i]),][1,])
      }
    }
  }
  for(u in (1:length(check_list))){
    a<-new[which(!new$a == check_list[u]),"a"]
    q<-new[which(!new$a == check_list[u]),"q"]
    a<-as.character(a)
    q<-as.character(q)
    l<-length(a)
    p1<-list()
    p3<-data.frame()
    tot<-list(1063,1834,1086,161,246,466,337,1072,1926,472)
    for(k in 1:ncol(Hallmarks_of_Cancer_TGen)){
      b<-Hallmarks_of_Cancer_TGen[,k]
      inter<-intersect(a,b)
      list.mu<-as.character(a)[which(as.character(a) %in% inter)]
      x<-length(list.mu)
      counts = (matrix(data = c(x, l-x, (as.numeric(tot[k])*(as.numeric(length(q)-sum(duplicated(q)))))-x, ((20345-as.numeric(tot[k]))*(as.numeric(length(q)-sum(duplicated(q)))))-l+x), nrow = 2))
      p3[k,1]<-(fisher.test(counts)$conf.int[1])
      p3[k,2]<-(fisher.test(counts)$conf.int[2])
      p1[k]<-(fisher.test(counts)$p.value)
    }
    final2[(1:10),u] <- p.adjust(p1,  method = "fdr")
    colnames(final2)[u] <- check_list[u]
  }
  rownames(final2)[(1:10)] <- colnames(Hallmarks_of_Cancer_TGen)[(1:10)]
  print(final2[,c(1,8)])
  write.table(final2,paste0("Y:/Users/mangiantel/PCA/NL-mutations/Results/", group[m] ,"_MutationRemoved_Hallmarks_2.txt"),row.names = F,col.names = T,quote = F, sep="\t")
}
